﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	
	Private ap As AnchorPane
	Private lvparent As ListView
	Private lbl As Label
	Private btnRndAnimation As Button
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(lv As ListView, text As String)
	lvparent = lv
	
	
	ap.Initialize("ap")
	ap.LoadLayout("Item")
	ap.Style = "-fx-background-color: #ff" & Rnd(10, 99) & Rnd(10, 99) & ";"
	lv.Items.Add(ap)
	lbl.text = text & CRLF & "Middle click: Scale animation and remove item." & CRLF & "Right click: Translate animation."
	
	
	'Start animation, when the item is created:
	Dim st As ScaleTransition
	st.Initialize(Me, 500, ap, "st")
	st.AutoReverse = True	
	st.FromX = 0
	st.FromY = 0	
	st.ToX = 1
	st.ToY = 1	
	st.CycleCount = 1
	st.Delay = lvparent.Items.Size * 10
	st.Play

End Sub

Private Sub btnRndAnimation_Action
	Select Rnd(1, 4)
		Case 1
			Dim st As ScaleTransition
			st.Initialize(Me, 125, ap, "")
			st.AutoReverse = True
			st.FromX = 1
			st.FromY = 1
			st.ToX = 2
			st.ToY = 0
			st.CycleCount = 4
			st.Play
		
		Case 2
			Dim rt As RotateTransition
			rt.Initialize(Me, 300, ap, "")
			rt.AutoReverse = True
			rt.FromAngle = 0
			rt.ToAngle = 45
			rt.CycleCount = 2
			rt.Play
			
		Case 3
			Dim tt As TranslateTransition
			tt.Initialize(Me, 75, ap, "")
			tt.AutoReverse = True
			tt.FromX = 0
			tt.FromY = 0
			tt.ToX = 25
			tt.ToY = -25
			tt.CycleCount = 6
			tt.Play
		
	End Select
	
End Sub

Private Sub ap_MouseClicked (EventData As MouseEvent)
	
	If EventData.MiddleButtonPressed Then
		Dim st As ScaleTransition
		st.Initialize(Me, 500, ap, "stClose")
		st.AutoReverse = False
		st.FromX = 1
		st.FromY = 1
		st.ToX = 0
		st.ToY = 0
		st.CycleCount = 0
		st.Play
	
	Else If EventData.SecondaryButtonPressed Then
		Dim tt As TranslateTransition
		tt.Initialize(Me, 125, ap, "")
		tt.AutoReverse = True
		tt.FromX = 0
		tt.FromY = 0
		tt.ToX = 25
		tt.ToY = 0
		tt.CycleCount = 2
		tt.Play
	
	Else
	
		Dim ft As FadeTransition
		ft.Initialize(Me, 500, ap, "ft")
		ft.AutoReverse = True
		ft.CycleCount = 4
		ft.FromValue = 1
		ft.ToValue = 0
		ft.Play
	End If
	
End Sub

Sub stClose_Finished
	Log("Custom event: Animation Finished")
	lvparent.Items.RemoveAt(lvparent.Items.IndexOf(ap))
	
End Sub